EQContoller.prototype.addListener = function(listener){ 
	this.listeners.push(listener);
}

EQContoller.prototype.isAnswered = function(){ 
	// abstract
	}

EQContoller.prototype.isModified = function(){ 
	// abstract
	}

EQContoller.prototype.getStatus = function(){ 
	return this.status;
}

EQContoller.prototype.updateView = function(){ 
	if(this.status == 0){ // saved
		this.view.setSavedState();
	}else if(this.status == 1){ // unsaved
		this.view.setUnsavedState();
	}else if(this.status == -1){ // Error
		this.view.setErrorState();
	}else if(this.status == 2){ // saving
		this.view.setSavingState();
	}else if(this.status == 3){ // loading
		this.view.setLoadingState();
	}
}

EQContoller.prototype.setStatus = function(status){ 
	this.status = status;
	var len=this.listeners.length;
	for(var i=0; i<len; i++) {
		this.listeners[i].update(this);
	}
	this.updateView();
}

EQContoller.prototype.checkChanges = function(){ 
	if(this.isModified()){
		this.setStatus(1);
	}else{
		this.setStatus(0);
	}
}

EQContoller.prototype.retrieveLocal = function(){
	this.setStatus(3);
	this.checkChanges();
}

/*
EQContoller.prototype.retrieve = function(){
	this.setStatus(3);
	
	var controller = this;
	$.post("/index.php", { action: "load", id: this.id },
		function(data){
			if (data.action=="load" && data.success=="true" && data.id==controller.id){
				controller.model.setText(data.data);
				controller.view.setText(data.data);
				controller.checkChanges();
			}else{
				controller.setStatus(-1);
			}
		}, "json");
}
*/

EQContoller.prototype.saveImmediate = function(){
	this.saveIntern(true);
}

EQContoller.prototype.save = function(){
	this.saveIntern(false);
}

EQContoller.prototype.verifySavedData = function(original, saved){
	//abstract
}

EQContoller.prototype.updateModel = function(saved){
	//abstract
}

EQContoller.prototype.getSaveData = function(){
	//abstract
}

EQContoller.prototype.saveIntern = function(immediate){
	this.setStatus(2);
	
	var dataToSave = this.getSaveData();
	var controller = this;
	$.ajax({
		type: 'POST',
		url: "",
		data: {
			action: "save", 
			id: this.id, 
			data: dataToSave
		},
		success: function(data){
			//alert(data);
			// TODO: Handle missing fields
			if (data.action=="save" && data.success=="true" && data.id==controller.id && controller.verifySavedData(data.data, dataToSave)){
				controller.updateModel(data.data);
				controller.checkChanges();
			}else{
				controller.setStatus(-1);
			}
		}, 
		dataType: "json",
		async : !immediate
	});
}

EQContoller.prototype.init = function(identifier, id){
	this.identifier = identifier;
	this.id = id;
	this.listeners = new Array();
	
	this.setStatus(0);
}

function EQContoller(){
	
}

