MCView.prototype = new EQView();
MCView.prototype.constructor = MCView;
MCView.prototype.parent = EQView.prototype;

MCView.prototype.getData = function(){
	var data = [];
	$("#mc-container-"+this.id).find('input:radio,input:checkbox').each(function(){
		var tupel_id = this.id.split('_', 3)[1];
		var answer = $(this).is(':checked');
		var explanation = $('#mc_'+tupel_id+"_explanation").val();
		//window.console.log(tupelID+": "+answer+"  "+explanation);
		var object = {
			tupel_id: tupel_id, 
			answer: answer ? 1 : 0
		}
		if(explanation != undefined){
			object.explanation = explanation;
		}
		data.push(object);
	});
	return data;
}

MCView.prototype.setData = function(data){
	//$("#qa-textarea-"+this.id).html(text);
}

MCView.prototype.setLoadingState = function(){
	this.parent.setLoadingState.call(this);
	
	$("#mc-container-"+this.id).find('td').css("box-shadow", "#999999 0 0 5px");
	$("#mc-container-"+this.id).find('input').attr('disabled', true);
	$("#mc-container-"+this.id).find('textarea').attr('disabled', true);
}

MCView.prototype.setSavingState = function(){
	this.parent.setSavingState.call(this);
		
	/// $("#qa-container-"+this.id).css("background-color", "#999999");
	$("#mc-container-"+this.id).find('input').attr('disabled', false);
	$("#mc-container-"+this.id).find('textarea').attr('disabled', false);
}

MCView.prototype.setSavedState = function(){
	this.parent.setSavedState.call(this);
	
	$("#mc-container-"+this.id).find('td').css("box-shadow", "#FFFFFF 0 0 5px");
	$("#mc-container-"+this.id).find('input').attr('disabled', false);
	$("#mc-container-"+this.id).find('textarea').attr('disabled', false);
}

MCView.prototype.setErrorState = function(){
	this.parent.setErrorState.call(this);
	
	$("#mc-container-"+this.id).find('td').css("box-shadow", "#FF0000 0 0 5px");
	$("#mc-container-"+this.id).find('input').attr('disabled', false);
	$("#mc-container-"+this.id).find('textarea').attr('disabled', false);
}

MCView.prototype.setUnsavedState = function(){
	this.parent.setUnsavedState.call(this);
	
	$("#mc-container-"+this.id).find('td').css("box-shadow", "#CCCC00 0 0 5px");
	$("#mc-container-"+this.id).find('input').attr('disabled', false);
	$("#mc-container-"+this.id).find('textarea').attr('disabled', false);
}

function MCView(id, controller){
	this.id = id;
	this.prefix = "mc";
	
	$("#mc-container-"+this.id).find('textarea').keyup(function(event) {
		controller.checkChanges();
	});
	
	$("#mc-container-"+this.id).find('input').change(function(event) {
		controller.checkChanges();
	});
	
	
	$("#mc-container-"+this.id).find('input:radio').each(function(){
		
		$(this).change(function(e){
			
			//window.console.log(this.id);
			var otherRadioButtons = $(this).parents('tr').find('input:radio').not($(this));
			//window.console.log(otherRadioButtons);
			if(otherRadioButtons.length <= 0){
				// in this case the single choice options are vertically orientated, and they all belong together
				otherRadioButtons = $(this).parents('table').find('input:radio').not($(this));
			}
			otherRadioButtons.attr('checked', false);
			
			controller.checkChanges();
			
		});
		
	});
	
}